/* 
 *    Programmed By: Mohammed Isam Mohammed [mohammed_isam1984@yahoo.com]
 *    Copyright 2018 (c)
 * 
 *    file: module_bas.c
 *    This file is part of mino.
 *
 *    mino is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    mino is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with mino.  If not, see <http://www.gnu.org/licenses/>.
 */    
#include "modules.h"

char *ext_bas[] = { "bas", "BAS" };
char *keyword_bas[] = {
      //BASIC language keywords
      //As in QBASIC v3.0
      "ABS",
      "ACS",
      "ADVAL",
      "AND",
      "ASC",
      "ASN",
      "AUTO",
      "BGET",
      "BPUT",
      "COLOR",
      "CALLS",
      "CHAIN",
      "CHR$",
      "CLEAR",
      "CLOSE",
      "CLG",
      "CLS",
      "COS",
      "DATA",
      "DEG",
      "DEFDBL",
      "DELETE",
      "DIV",
      "DIM",
      "DRAW",
      "ENDPROC",
      "END",
      "ENVELOPE",
      "ELSEIF",
      "EVAL",
      "ERL",
      "EOF",
      "EOR",
      "ERROR",
      "EXP",
      "EXIT",
      "FOR",
      "FALSE",
      "FN",
      "GOTO$",
      "GET$",
      "GET",
      "GOSUB",
      "GCOL",
      "HIMEM",
      "INPUT$",
      "IF",
      "INKEY$",
      "INKEY",
      "INT",
      "INSTR",
      "LIST",
      "LOAD",
      "LOMEM",
      "LOCAL",
      "LEFT$",
      "LEN",
      "LET",
      "LOG",
      "LN",
      "MID$",
      "MODE",
      "MOD",
      "MOVE",
      "NEXT",
      "NEW",
      "NOT",
      "OLD",
      "ON",
      "OFF",
      "OR",
      "OPENIN",
      "OPENOUT",
      "PRINT#",
      "PAGE",
      "PTR",
      "PI",
      "PLOT",
      "PROC",
      "POS",
      "RETURN",
      "REPEAT",
      "REPORT",
      "READ",
      "REM",
      "RUN",
      "RAD",
      "RESTORE",
      "RIGHT$",
      "RND",
      "RENUMBER",
      "SAVE",
      "SGN",
      "SIN",
      "SQR",
      "SOUND",
      "SPC",
      "STR$",
      "STRING$",
      "STOP",
      "TAN",
      "TAB",
      "TIME$",
      "TRACE",
      "TRUE",
      "UNTIL",
      "USR0",
      "VDU",
      "VAL",
      "VPOS",
      "WIDTH",
      ////////////////////////////////////////////
      "ACCESS",
      "APPEND",
      "AS",
      "ATN",
      "BASE",
      "BEEP",
      "BLOAD",
      "BSAVE",
      "CALL",
      "CASE",
      "CDBL",
      "CHDIR",
      "CINT",
      "CIRCLE",
      "COMMAND$",
      "COMMON",
      "COM",
      "CONST",
      "CONT",
      "CSNG",
      "CSRLIN",
      "CVDMBF",
      "CVD",
      "CVSMBF",
      "CVI",
      "CVS",
      "DATE$",
      "DO",
      "DEFINT",
      "DEFSNG",
      "DEFSTR",
      "DEF",
      "DRAW",
      "EDIT",
      "ELSE",
      "ENVIRON$",
      "ENVIRON",
      "EQV",
      "ERASE",
      "ERDEV$",
      "ERDEV",
      "ERR",
      "FIELD",
      "FILES",
      "FIX",
      "FRE",
      "GOTO",
      "GO",
      "HEX$",
      "IMP",
      "INPUT#",
      "INPUT",
      "INP",
      "IOCTL$",
      "IOCTL",
      "KEY",
      "KILL",
      "LBOUND",
      "LCOPY",
      "LINE",
      "LLIST",
      "LOCATE",
      "LOCK",
      "LOC",
      "LOF",
      "LOOP",
      "LPOS",
      "LPRINT#",
      "LPRINT",
      "LSET",
      "MERGE",
      "MKD$",
      "MKDIR",
      "MKDMBF$",
      "MKI$",
      "MKS$",
      "MKSMBF$",
      "MOTOR",
      "NAME",
      "NOISE",
      "NULL",
      "OCT$",
      "OPEN",
      "COM",
      "OPTION",
      "OUTPUT",
      "OUT",
      "PAINT",
      "PALETTE",
      "USING",
      "PEEK",
      "PEN",
      "PLAY",
      "PMAP",
      "POINT",
      "POKE",
      "PRESET",
      "PRINT",
      "PSET",
      "PUT",
      "RANDOMIZE",
      "RANDOM",
      "REDIM",
      "RENUM",
      "RESET",
      "RESUME",
      "RMDIR",
      "RSET",
      "SADD",
      "SCREEN",
      "SEG",
      "SELECT",
      "SHARED",
      "SHELL",
      "SPACE$",
      "SPACE",
      "STATIC",
      "STEP",
      "STICK",
      "STRIG",
      "SUB",
      "SWAP",
      "SYSTEM",
      "THEN",
      "TIMER",
      "TIME",
      "TO",
      "TROFF",
      "TRON",
      "UBOUND",
      "UNLOCK",
      "USING",
      "USR1",
      "USR2",
      "USR3",
      "USR4",
      "USR5",
      "USR6",
      "USR7",
      "USR8",
      "USR9",
      "USR",
      "VARPTR$",
      "VARPTR",
      "VIEW",
      "WAIT",
      "WEND",
      "WHILE",
      "WINDOW",
      "WRITE#",
      "WRITE",
      "XOR",
};

struct modulestruct module_bas =
{
    .extsCount      = 2,
    .exts           = ext_bas,
    .keywordCount   = 263,
    .keywords       = keyword_bas,
    .mlCommentStart = NULL,
    .mlCommentEnd   = NULL,
    .slCommentStart = "REM",
    .caseSensitive  = 0,
};
