/* 
 *    Programmed By: Mohammed Isam Mohammed [mohammed_isam1984@yahoo.com]
 *    Copyright 2018 (c)
 * 
 *    file: module_pas.c
 *    This file is part of mino.
 *
 *    mino is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    mino is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with mino.  If not, see <http://www.gnu.org/licenses/>.
 */    
#include "modules.h"

char *ext_pas[] = { "pas", "PAS" };
char *keyword_pas[] = {
      //GNU Pascal language keywords
      "absolute",
      "abstract",
      "all",
      "and",
      "and_then",
      "array",
      "asm",
      "asmname",
      "as",
      "attribute",
      "begin",
      "bindable",
      "case",
      "c_language",
      "class",
      "constructor",
      "const",
      "destructor",
      "div",
      "downto",
      "double",
      "else",
      "end",
      "exports",
      "export",
      "external",
      "far",
      "filepos",
      "finalization",
      "forward",
      "formatstring",
      "function",
      "goto",
      "if",
      "implementation",
      "import",
      "inherited",
      "initializaion",
      "interface",
      "interrupt",
      "include",
      "is",
      "label",
      "library",
      "module",
      "mod",
      "name",
      "near",
      "nil",
      "not",
      "object",
      "of",
      "only",
      "operator",
      "or_else",
      "ord",
      "otherwise",
      "packed",
      "pow",
      "private",
      "procedure",
      "program",
      "property",
      "protected",
      "public",
      "published",
      "qualified",
      "record",
      "repeat",
      "resident",
      "restricted",
      "segment",
      "setfiletime",
      "shl",
      "shr",
      "then",
      "to",
      "typeof",
      "unit",
      "until",
      "uses",
      "value",
      "var",
      "view",
      "virtual",
      "while",
      "with",
      "xor",
      ///////////////////////////////////////////
      "abs",
      "addr",
      "alignof",
      "ansichar",
      "anyfile",
      "append",
      "arccos",
      "arcsin",
      "arctan",
      "arg",
      "assert",
      "assigned",
      "assign",
      "bindingtype",
      "binding",
      "bind",
      "bitsizeof",
      "blockread",
      "blockwrite",
      "boolean",
      "break",
      "byteint",
      "bytecard",
      "byteint",
      "byte",
      "cardinal",
      "card",
      "cintean",
      "ccardinal",
      "char",
      "chdir",
      "chr",
      "cinteger",
      "close",
      "cmplx",
      "complex",
      "compilerassert",
      "comp",
      "concat",
      "conjugate",
      "continue",
      "copy",
      "cos",
      "cstring2string",
      "cstringcopystring",
      "cstring",
      "currentroutinename",
      "cword",
      "cycle",
      "date",
      "dec",
      "definesize",
      "delete",
      "discard",
      "dispose",
      "do",
      "empty",
      "eof",
      "eoln",
      "epsreal",
      "eqpad",
      "eq",
      "erase",
      "exclude",
      "exit",
      "exp",
      "extended",
      "extend",
      "fail",
      "false",
      "filesize",
      "file",
      "fillchar",
      "finalize",
      "flush",
      "forward",
      "for",
      "frac",
      "frameaddress",
      "freemem",
      "gepad",
      "getmem",
      "gettimestamp",
      "get",
      "ge",
      "gtpad",
      "gt",
      "im",
      "inc",
      "index",
      "initialize",
      "inoutres",
      "input",
      "insert",
      "integer",
      "ioresult",
      "int",
      "in",
      "lastposition",
      "leave",
      "length",
      "lepad",
      "le",
      "ln",
      "locase",
      "longint",
      "longcard",
      "longestint",
      "longestcard",
      "longestint",
      "longestreal",
      "longestword",
      "longint",
      "longreal",
      "longword",
      "low",
      "ltpad",
      "lt",
      "mark",
      "maxchar",
      "maxint",
      "maxreal",
      "max",
      "medint",
      "medcard",
      "medint",
      "medreal",
      "medword",
      "minreal",
      "min",
      "mkdir",
      "moveleft",
      "moveright",
      "move",
      "nepad",
      "newcstring",
      "new",
      "ne",
      "null",
      "odd",
      "or",
      "output",
      "pack",
      "page",
      "pansichar",
      "paramcount",
      "paramstr",
      "pchar",
      "pi",
      "pobjecttype",
      "pointer",
      "polar",
      "position",
      "pos",
      "pred",
      "ptrcard",
      "ptrdifftype",
      "ptrint",
      "ptrword",
      "put",
      "randomize",
      "random",
      "readstr",
      "readln",
      "read",
      "real",
      "release",
      "rename",
      "reset",
      "result",
      "returnaddress",
      "return",
      "rewrite",
      "rmdir",
      "re",
      "round",
      "runerror",
      "seekwrite",
      "seekupdate",
      "seekread",
      "seekeoln",
      "seekeof",
      "seek",
      "self",
      "setlength",
      "settype",
      "set",
      "shortint",
      "shortcard",
      "shortint",
      "shortreal",
      "shortword",
      "single",
      "sin",
      "sizeof",
      "sizetype",
      "smallint",
      "sqrt",
      "sqr",
      "standarderror",
      "standardinput",
      "standardoutput",
      "stderr",
      "string2cstring",
      "string",
      "str",
      "substr",
      "succ",
      "text",
      "timestamp",
      "time",
      "trim",
      "true",
      "truncate",
      "trunc",
      "type",
      "unbind",
      "unpack",
      "upcase",
      "update",
      "val",
      "void",
      "wordint",
      "word",
      "writeln",
      "writestr",
      "write",
};

struct modulestruct module_pas =
{
    .extsCount      = 2,
    .exts           = ext_pas,
    .keywordCount   = 315,
    .keywords       = keyword_pas,
    .mlCommentStart = "{*",
    .mlCommentEnd   = "*}",
    .slCommentStart = "{",
    .caseSensitive  = 0,
};
