/* 
 *    Programmed By: Mohammed Isam Mohammed [mohammed_isam1984@yahoo.com]
 *    Copyright 2018 (c)
 * 
 *    file: module_perl.c
 *    This file is part of mino.
 *
 *    mino is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    mino is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with mino.  If not, see <http://www.gnu.org/licenses/>.
 */    
#include "modules.h"

char *ext_perl[] = { "pl", "PL" };
char *keyword_perl[] = {
      //PERL functions
      "-A",
      "-B",
      "-b",
      "-C",
      "-c",
      "-d",
      "-e",
      "-f",
      "-g",
      "-k",
      "-l",
      "-M",
      "-O",
      "-o",
      "-p",
      "-r",
      "-R",
      "-s",
      "-S",
      "-T",
      "-t",
      "-u",
      "-w",
      "-W",
      "-X",
      "-x",
      "-z",
      "abs",
      "accept",
      "alarm",
      "atan2",
      "AUTOLOAD",
      "BEGIN",
      "bind",
      "binmode",
      "bless",
      "break",
      "caller",
      "chdir",
      "CHECK",
      "chmod",
      "chomp",
      "chop",
      "chown",
      "chr",
      "chroot",
      "close",
      "closedir",
      "connect",
      "cos",
      "crypt",
      "dbmclose",
      "dbmopen",
      "defined",
      "delete",
      "DESTROY",
      "die",
      "dump",
      "each",
      "END",
      "endgrent",
      "endhostent",
      "endprotoent",
      "endpwent",
      "endservent",
      "eof",
      "eval",
      "exec",
      "exists",
      "exit",
      "fcntl",
      "fileno",
      "flock",
      "fork",
      "format",
      "formline",
      "getc",
      "getgrent",
      "getgrgid",
      "getgrnam",
      "gethostbyaddr",
      "gethostbyname",
      "gethostent",
      "getlogin",
      "getnetbyaddr",
      "getnetbyname",
      "getnetent",
      "getpeername",
      "getpgrp",
      "getppid",
      "getpriority",
      "getprotobyname",
      "getprotobynumber",
      "getprotoent",
      "getpwent",
      "getpwnam",
      "getpwuid",
      "getservbyname",
      "getservbyport",
      "getservent",
      "getsockname",
      "getsockopt",
      "glob",
      "gmtime",
      "goto",
      "grep",
      "hex",
      "index",
      "INIT",
      "int",
      "ioctl",
      "join",
      "keys",
      "kill",
      "last",
      "lc",
      "lcfirst",
      "length",
      "link",
      "listen",
      "local",
      "localtime",
      "log",
      "lstat",
      "map",
      "mkdir",
      "msgctl",
      "msgget",
      "msgrcv",
      "msgsnd",
      "my",
      "next",
      "not",
      "oct",
      "open",
      "opendir",
      "ord",
      "our",
      "pack",
      "pipe",
      "pop",
      "pos",
      "print",
      "printf",
      "prototype",
      "push",
      "quotemeta",
      "rand",
      "read",
      "readdir",
      "readline",
      "readlink",
      "readpipe",
      "recv",
      "redo",
      "ref",
      "rename",
      "require",
      "reset",
      "return",
      "reverse",
      "rewinddir",
      "rindex",
      "rmdir",
      "say",
      "scalar",
      "seek",
      "seekdir",
      "select",
      "semctl",
      "semget",
      "semop",
      "send",
      "setgrent",
      "sethostent",
      "setnetent",
      "setpgrp",
      "setpriority",
      "setprotoent",
      "setpwent",
      "setservent",
      "setsockopt",
      "shift",
      "shmctl",
      "shmget",
      "shmread",
      "shmwrite",
      "shutdown",
      "sin",
      "sleep",
      "socket",
      "socketpair",
      "sort",
      "splice",
      "split",
      "sprintf",
      "sqrt",
      "srand",
      "stat",
      "state",
      "study",
      "substr",
      "symlink",
      "syscall",
      "sysopen",
      "sysread",
      "sysseek",
      "system",
      "syswrite",
      "tell",
      "telldir",
      "tie",
      "tied",
      "time",
      "times",
      "truncate",
      "uc",
      "ucfirst",
      "umask",
      "undef",
      "UNITCHECK",
      "unlink",
      "unpack",
      "unshift",
      "untie",
      "use",
      "utime",
      "values",
      "vec",
      "wait",
      "waitpid",
      "wantarray",
      "warn",
      "write",
      //PERL syntax
      "__DATA__",
      "__END__",
      "__FILE__",
      "__LINE__",
      "__PACKAGE__",
      "and",
      "cmp",
      "continue",
      "CORE",
      "do",
      "else",
      "elsif",
      "eq",
      "exp",
      "for",
      "foreach",
      "ge",
      "gt",
      "if",
      "le",
      "lock",
      "lt",
      "m",
      "ne",
      "no",
      "or",
      "package",
      "q",
      "qq",
      "qr",
      "qw",
      "qx",
      "s",
      "sub",
      "tr",
      "unless",
      "until",
      "while",
      "xor",
      "y",
      //PERL variables
      "$!",
      "$\"",
      "$#",
      "$$",
      "$%",
      "$&",
      "$'",
      "$(",
      "$)",
      "$*",
      "$+",
      "$,",
      "$-",
      "$.",
      "$/",
      "$0",
      "$:",
      "$;",
      "$<",
      "$=",
      "$>",
      "$?",
      "$@",
      "$[",
      "$\\",
      "$]",
      "$^",
      "$^A",
      "$^C",
      "$^CHILD_ERROR_NATIVE",
      "$^D",
      "$^E",
      "$^ENCODING",
      "$^F",
      "$^H",
      "$^I",
      "$^L",
      "$^M",
      "$^N",
      "$^O",
      "$^OPEN",
      "$^P",
      "$^R",
      "$^RE_DEBUG_FLAGS",
      "$^RE_TRIE_MAXBUF",
      "$^S",
      "$^T",
      "$^TAINT",
      "$^UNICODE",
      "$^UTF8LOCALE",
      "$^V",
      "$^W",
      "$^WARNING_BITS",
      "$^WIDE_SYSTEM_CALLS",
      "$^X",
      "$_",
      "$`",
      "$a",
      "$ACCUMULATOR",
      "$ARG",
      "$ARGV",
      "$b",
      "$BASETIME",
      "$CHILD_ERROR",
      "$COMPILING",
      "$DEBUGGING",
      "$EFFECTIVE_GROUP_ID",
      "$EFFECTIVE_USER_ID",
      "$EGID",
      "$ERRNO",
      "$EUID",
      "$EVAL_ERROR",
      "$EXCEPTIONS_BEING_CAUGHT",
      "$EXECUTABLE_NAME",
      "$EXTENDED_OS_ERROR",
      "$FORMAT_FORMFEED",
      "$FORMAT_LINE_BREAK_CHARACTERS",
      "$FORMAT_LINES_LEFT",
      "$FORMAT_LINES_PER_PAGE",
      "$FORMAT_NAME",
      "$FORMAT_PAGE_NUMBER",
      "$FORMAT_TOP_NAME",
      "$GID",
      "$INPLACE_Mino",
      "$INPUT_LINE_NUMBER",
      "$INPUT_RECORD_SEPARATOR",
      "$LAST_MATCH_END",
      "$LAST_PAREN_MATCH",
      "$LAST_REGEXP_CODE_RESULT",
      "$LIST_SEPARATOR",
      "$MATCH",
      "$MULTILINE_MATCHING",
      "$NR",
      "$OFMT",
      "$OFS",
      "$ORS",
      "$OS_ERROR",
      "$OSNAME",
      "$OUTPUT_AUTO_FLUSH",
      "$OUTPUT_FIELD_SEPARATOR",
      "$OUTPUT_RECORD_SEPARATOR",
      "$PERL_VERSION",
      "$PERLDB",
      "$PID",
      "$POSMATCH",
      "$PREMATCH",
      "$PROCESS_ID",
      "$PROGRAM_NAME",
      "$REAL_GROUP_ID",
      "$REAL_USER_ID",
      "$RS",
      "$SUBSCRIPT_SEPARATOR",
      "$SUBSEP",
      "$SYSTEM_FD_MAX",
      "$UID",
      "$WARNING",
      "$|",
      "$~",
      "%!",
      "%^H",
      "%ENV",
      "%INC",
      "%OVERLOAD",
      "%SIG",
      "@+",
      "@-",
      "@_",
      "@ARGV",
      "@INC",
      "@LAST_MATCH_START",
      //PERL file handles
      "ARGV",
      "ARGVOUT",
      "STDERR",
      "STDIN",
      "STDOUT",
};

struct modulestruct module_perl =
{
    .extsCount      = 2,
    .exts           = ext_perl,
    .keywordCount   = 409,
    .keywords       = keyword_perl,
    .mlCommentStart = NULL,
    .mlCommentEnd   = NULL,
    .slCommentStart = "#",
    .caseSensitive  = 1,
};
