/* 
 *    Programmed By: Mohammed Isam Mohammed [mohammed_isam1984@yahoo.com]
 *    Copyright 2018 (c)
 * 
 *    file: module_sh.c
 *    This file is part of mino.
 *
 *    mino is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    mino is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with mino.  If not, see <http://www.gnu.org/licenses/>.
 */    
#include "modules.h"

char *ext_texi[] = { "texi", "txi", "texinfo" };
char *keyword_texi[] = {
      //TEXI keywords
      "@!",
      "@\"",
      "@'",
      "@*",
      "@,",
      "@-",
      "@.",
      "@/",
      "@:",
      "@=",
      "@?",
      "@@",
      "@atchar",
      "@\\",
      "@^",
      "@`",
      "@{",
      "@lbracechar",
      "@}",
      "@rbracechar",
      "@~",
      "@AA",
      "@aa",
      "@abbr",
      "@acronym",
      "@AE",
      "@ae",
      "@afivepaper",
      "@afourlatex",
      "@afourpaper",
      "@afourwide",
      "@alias",
      "@allowcodebreaks",
      "@anchor",
      "@appendixsection",
      "@appendixsec",
      "@appendixsubsec",
      "@appendixsubsubsec",
      "@appendix",
      "@arrow",
      "@asis",
      "@author",
      "@bullet",
      "@bye",
      "@b",
      "@caption",
      "@cartouche",
      "@centerchap",
      "@center",
      "@chapheading",
      "@chapter",
      "@cindex",
      "@cite",
      "@clear",
      "@clicksequence",
      "@clickstyle",
      "@click",
      "@codequotebacktick",
      "@codequoteundirected",
      "@code",
      "@command",
      "@comma",
      "@comment",
      "@contents",
      "@copying",
      "@copyright",
      "@c",
      "@defcodeindex",
      "@defcvx",
      "@defcv",
      "@deffnx",
      "@deffn",
      "@defindex",
      "@definfoenclose",
      "@defivarx",
      "@defivar",
      "@defmacx",
      "@defmac",
      "@defmethodx",
      "@defmethod",
      "@defoptx",
      "@defopt",
      "@defopx",
      "@defop",
      "@defspecx",
      "@defspec",
      "@deftpx",
      "@deftp",
      "@deftypecvx",
      "@deftypecv",
      "@deftypefnnewline",
      "@deftypefnx",
      "@deftypefn",
      "@deftypefunx",
      "@deftypefun",
      "@deftypeivarx",
      "@deftypeivar",
      "@deftypemethodx",
      "@deftypemethod",
      "@deftypeopx",
      "@deftypeop",
      "@deftypevarx",
      "@deftypevar",
      "@deftypevrx",
      "@deftypevr",
      "@defunx",
      "@defun",
      "@defvarx",
      "@defvar",
      "@defvrx",
      "@defvr",
      "@detailmenu",
      "@dfn",
      "@DH",
      "@dh",
      "@dircategory",
      "@direntry",
      "@display",
      "@dmn",
      "@docbook",
      "@documentdescription",
      "@documentlanguage",
      "@dotaccent",
      "@dotless",
      "@dots",
      "@email",
      "@emph",
      "@enddots",
      "@end",
      "@enumerate",
      "@env",
      "@equiv",
      "@errormsg",
      "@error",
      "@euro",
      "@evenfooting",
      "@evenheading",
      "@exampleindent",
      "@example",
      "@exclamdown",
      "@exdent",
      "@expansion",
      "@file",
      "@finalout",
      "@findex",
      "@firstparagraphindent",
      "@float",
      "@flushleft",
      "@flushright",
      "@fonttextsize",
      "@footnotestyle",
      "@footnote",
      "@format",
      "@frenchspacing",
      "@ftable",
      "@geq",
      "@group",
      "@guillemetleft",
      "@guillemetright",
      "@guillemotleft",
      "@guillemotright",
      "@guilsinglleft",
      "@guilsinglright",
      "@H",
      "@hashchar",
      "@headings",
      "@heading",
      "@headitemfont",
      "@headitem",
      "@html",
      "@hyphenation",
      "@ifcommanddefined",
      "@ifcommandnotdefined",
      "@ifdocbook",
      "@ifhtml",
      "@ifinfo",
      "@ifnotdocbook",
      "@ifnothtml",
      "@ifnotplaintext",
      "@ifnottex",
      "@ifnotxml",
      "@ifnotinfo",
      "@ifplaintext",
      "@ifset",
      "@iftex",
      "@ifxml",
      "@ignore",
      "@image",
      "@include",
      "@indentedblock",
      "@indent",
      "@indicateurl",
      "@inforef",
      "@inlinefmtifelse",
      "@inlinefmt",
      "@inlineifclear",
      "@inlineifset",
      "@inlineraw",
      "\\input",
      "@insertcopying",
      "@itemize",
      "@itemx",
      "@item",
      "@i",
      "@kbdinputstyle",
      "@kbd",
      "@key",
      "@kindex",
      "@LaTeX",
      "@leq",
      "@lisp",
      "@listoffloats",
      "@lowersections",
      "@L",
      "@l",
      "@macro",
      "@majorheading",
      "@math",
      "@menu",
      "@minus",
      "@multitable",
      "@need",
      "@node",
      "@noindent",
      "@novalidate",
      "@oddfooting",
      "@oddheading",
      "@OE",
      "@oe",
      "@ogonek",
      "@option",
      "@ordf",
      "@ordm",
      "@O",
      "@o",
      "@pagesizes",
      "@page",
      "@paragraphindent",
      "@part",
      "@pindex",
      "@point",
      "@pounds",
      "@printindex",
      "@print",
      "@pxref",
      "@questiondown",
      "@quotation",
      "@quotedblleft",
      "@quotedblright",
      "@quoteleft",
      "@quoteright",
      "@quotedblbase",
      "@quotesinglbase",
      "@raggedright",
      "@raisesections",
      "@refill",
      "@ref",
      "@registeredsymbol",
      "@result",
      "@ringaccent",
      "@r",
      "@samp",
      "@sansserif",
      "@sc",
      "@section",
      "@setchapternewpage",
      "@setcontentsaftertitlepage",
      "@setfilename",
      "@setshortcontentsaftertitlepage",
      "@settitle",
      "@set",
      "@shortcaption",
      "@shortcontents",
      "@shorttitlepage",
      "@slanted",
      "@smallbook",
      "@smalldisplay",
      "@smallexample",
      "@smallformat",
      "@smallindentedblock",
      "@smalllisp",
      "@smallquotation",
      "@sp",
      "@ss",
      "@strong",
      "@subheading",
      "@subsection",
      "@subsubheading",
      "@subsubsection",
      "@subtitle",
      "@summarycontents",
      "@syncodeindex",
      "@synindex",
      "@table",
      "@tab",
      "@textdegree",
      "@TeX",
      "@tex",
      "@thischapter",
      "@thischaptername",
      "@thischapternum",
      "@thisfile",
      "@thispage",
      "@thistitle",
      "@TH",
      "@th",
      "@tieaccent",
      "@tie",
      "@tindex",
      "@titlefont",
      "@titlepage",
      "@title",
      "@today",
      "@top",
      "@t",
      "@ubaraccent",
      "@udotaccent",
      "@unmacro",
      "@unnumberedsec",
      "@unnumberedsubsec",
      "@unnumberedsubsubsec",
      "@unnumbered",
      "@url",
      "@urefbreakstyle",
      "@uref",
      "@u",
      "@value",
      "@var",
      "@verbatiminclude",
      "@verbatim",
      "@verb",
      "@vindex",
      "@vskip",
      "@vtable",
      "@v",
      "@w",
      "@xml",
      "@xrefautomaticsectiontitle",
      "@xref",
      "@",
};

struct modulestruct module_texi =
{
    .extsCount      = 3,
    .exts           = ext_texi,
    .keywordCount   = 340,
    .keywords       = keyword_texi,
    .mlCommentStart = NULL,
    .mlCommentEnd   = NULL,
    .slCommentStart = "@comment",
    .caseSensitive  = 1,
};
